Package org.jbpm.workflow.instance.node

## Class WorkItemNodeInstance

- java.lang.Object
- - org.jbpm.workflow.instance.impl.NodeInstanceImpl
  - - org.jbpm.workflow.instance.impl.ExtendedNodeInstanceImpl
    - - org.jbpm.workflow.instance.node.StateBasedNodeInstance
      - - org.jbpm.workflow.instance.node.WorkItemNodeInstance

- All Implemented Interfaces:
    `Serializable`, `ContextInstanceContainer`, `EventBasedNodeInstanceInterface`, `NodeInstance`, `org.kie.api.runtime.process.EventListener`, `org.kie.api.runtime.process.NodeInstance`
  Direct Known Subclasses:
    `HumanTaskNodeInstance`

      public class WorkItemNodeInstance
      extends StateBasedNodeInstance
      implements org.kie.api.runtime.process.EventListener, ContextInstanceContainer

  Runtime counterpart of a work item node.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.jbpm.workflow.instance.impl.NodeInstanceImpl

      `NodeInstanceImpl.NodeInstanceTrigger`

    - ### Nested classes/interfaces inherited from interface org.jbpm.workflow.instance.NodeInstance

      `NodeInstance.CancelType`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected org.drools.core.process.instance.WorkItem` | `workItem` |

    - ### Fields inherited from class org.jbpm.workflow.instance.impl.NodeInstanceImpl

      `cancelType, dynamicParameters, slaCompliance, slaDueDate, slaTimerId, triggerTime, UNIQUE_ID`

    - ### Fields inherited from interface org.jbpm.workflow.instance.NodeInstance

      `METADATA_WRAP_ASYNC_NODE`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `WorkItemNodeInstance()` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addContextInstance​(String contextId, ContextInstance contextInstance)` |
    `void` | `addEventListeners()` |
    `void` | `addExceptionProcessListener()` |
    `void` | `cancel​(NodeInstance.CancelType cancelType)` |
    `protected org.drools.core.process.instance.WorkItem` | `createWorkItem​(WorkItemNode workItemNode)` |
    `ContextContainer` | `getContextContainer()` |
    `ContextInstance` | `getContextInstance​(String contextId, long id)` |
    `ContextInstance` | `getContextInstance​(Context context)` |
    `List<ContextInstance>` | `getContextInstances​(String contextId)` |
    `String[]` | `getEventTypes()` |
    `long` | `getExceptionHandlingProcessInstanceId()` |
    `protected org.kie.api.runtime.KieRuntime` | `getKieRuntimeForExceptionSubprocess()` |
    `protected org.kie.api.runtime.KieRuntime` | `getKieRuntimeForSubprocess()` |
    `protected org.kie.api.runtime.KieRuntime` | `getKieRuntimeForSubprocess​(org.kie.api.runtime.manager.Context<?> context)` |
    `String` | `getNodeName()` |
    `protected Map<String,​Object>` | `getSourceParameters​(DataAssociation association)` |
    `int` | `getTriggerCount()` |
    `org.drools.core.process.instance.WorkItem` | `getWorkItem()` |
    `long` | `getWorkItemId()` |
    `protected WorkItemNode` | `getWorkItemNode()` |
    `void` | `internalSetProcessInstanceId​(long processInstanceId)` |
    `void` | `internalSetTriggerCount​(int triggerCount)` |
    `void` | `internalSetWorkItem​(org.drools.core.process.instance.WorkItem workItem)` |
    `void` | `internalSetWorkItemId​(long workItemId)` |
    `void` | `internalTrigger​(org.kie.api.runtime.process.NodeInstance from, String type)` |
    `boolean` | `isInversionOfControl()` |
    `void` | `removeContextInstance​(String contextId, ContextInstance contextInstance)` |
    `void` | `removeEventListeners()` |
    `void` | `removeExceptionProcessListeners()` |
    `static void` | `setVariableStrictOption​(boolean turnedOn)` |
    `protected void` | `setWorkItemParameters​(WorkItemNode workItemNode)` |
    `protected void` | `setWorkItemParametersFromDataAssociations​(WorkItemNode workItemNode)` |
    `protected void` | `setWorkItemParametersFromStringReplacement​(WorkItemNode workItemNode)` |
    `void` | `signalEvent​(String type, Object event)` |
    `void` | `triggerCompleted​(org.drools.core.process.instance.WorkItem workItem)` |
    `protected void` | `updateVariablesFromResult​(org.drools.core.process.instance.WorkItem workItem, WorkItemNode workItemNode)` |
    `void` | `validateWorkItemResultVariable​(String processName, List<DataAssociation> outputs, org.drools.core.process.instance.WorkItem workItem)` |
    `void` | `workItemAborted​(org.drools.core.process.instance.WorkItem workItem)` |
    `void` | `workItemCompleted​(org.drools.core.process.instance.WorkItem workItem)` |

    - ### Methods inherited from class org.jbpm.workflow.instance.node.StateBasedNodeInstance

      `addTimerListener, checkDeclarationMatch, checkProcessInstance, configureSla, configureTimerInstance, createTimerInstance, getActivationType, getEventBasedNode, getTimerInstances, handleSLAViolation, internalSetTimerInstances, mapDynamicOutputData, registerBoundaryEvents, resolveVariable, triggerCompleted, triggerCompleted, triggerTimer`

    - ### Methods inherited from class org.jbpm.workflow.instance.impl.ExtendedNodeInstanceImpl

      `getExtendedNode, handleAssignment, mapOutputSetVariables, mapOutputSetVariables, triggerCompleted, triggerEvent`

    - ### Methods inherited from class org.jbpm.workflow.instance.impl.NodeInstanceImpl

      `cancel, executeAction, followConnection, getCancelType, getExecutionErrorHandler, getFrom, getId, getLevel, getMetaData, getMetaData, getNode, getNodeId, getNodeInstanceContainer, getProcessInstance, getSlaCompliance, getSlaDueDate, getSlaTimerId, getTriggerTime, getUniqueId, getVariable, internalSetSlaCompliance, internalSetSlaDueDate, internalSetSlaTimerId, isAborted, resolveContext, resolveContextInstance, resolveContextInstance, retrigger, setAborted, setDynamicParameters, setId, setLevel, setMetaData, setNodeId, setNodeInstanceContainer, setProcessInstance, setVariable, trigger, triggerConnection, triggerNode, triggerNode, triggerNodeInstance, triggerNodeInstance`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### workItem

          protected transient org.drools.core.process.instance.WorkItem workItem

  - ### Constructor Detail

    - #### WorkItemNodeInstance

          public WorkItemNodeInstance()

  - ### Method Detail

    - #### getWorkItemNode

          protected WorkItemNode getWorkItemNode()

    - #### getWorkItem

          public org.drools.core.process.instance.WorkItem getWorkItem()

    - #### getWorkItemId

          public long getWorkItemId()

    - #### internalSetWorkItemId

          public void internalSetWorkItemId​(long workItemId)

    - #### internalSetWorkItem

          public void internalSetWorkItem​(org.drools.core.process.instance.WorkItem workItem)

    - #### isInversionOfControl

          public boolean isInversionOfControl()

      Overrides:
        `isInversionOfControl` in class `NodeInstanceImpl`

    - #### internalTrigger

          public void internalTrigger​(org.kie.api.runtime.process.NodeInstance from,
                                      String type)

      Overrides:
        `internalTrigger` in class `StateBasedNodeInstance`

    - #### createWorkItem

          protected org.drools.core.process.instance.WorkItem createWorkItem​(WorkItemNode workItemNode)

    - #### setWorkItemParameters

          protected void setWorkItemParameters​(WorkItemNode workItemNode)

    - #### setWorkItemParametersFromDataAssociations

          protected void setWorkItemParametersFromDataAssociations​(WorkItemNode workItemNode)

    - #### setWorkItemParametersFromStringReplacement

          protected void setWorkItemParametersFromStringReplacement​(WorkItemNode workItemNode)

    - #### triggerCompleted

          public void triggerCompleted​(org.drools.core.process.instance.WorkItem workItem)

    - #### updateVariablesFromResult

          protected void updateVariablesFromResult​(org.drools.core.process.instance.WorkItem workItem,
                                                   WorkItemNode workItemNode)

    - #### cancel

          public void cancel​(NodeInstance.CancelType cancelType)

      Specified by:
        `cancel` in interface `NodeInstance`
      Overrides:
        `cancel` in class `StateBasedNodeInstance`

    - #### addEventListeners

          public void addEventListeners()

      Specified by:
        `addEventListeners` in interface `EventBasedNodeInstanceInterface`
      Overrides:
        `addEventListeners` in class `StateBasedNodeInstance`

    - #### removeEventListeners

          public void removeEventListeners()

      Specified by:
        `removeEventListeners` in interface `EventBasedNodeInstanceInterface`
      Overrides:
        `removeEventListeners` in class `StateBasedNodeInstance`

    - #### signalEvent

          public void signalEvent​(String type,
                                  Object event)

      Specified by:
        `signalEvent` in interface `org.kie.api.runtime.process.EventListener`
      Overrides:
        `signalEvent` in class `StateBasedNodeInstance`

    - #### getEventTypes

          public String[] getEventTypes()

      Specified by:
        `getEventTypes` in interface `org.kie.api.runtime.process.EventListener`
      Overrides:
        `getEventTypes` in class `StateBasedNodeInstance`

    - #### workItemAborted

          public void workItemAborted​(org.drools.core.process.instance.WorkItem workItem)

    - #### workItemCompleted

          public void workItemCompleted​(org.drools.core.process.instance.WorkItem workItem)

    - #### getNodeName

          public String getNodeName()

      Specified by:
        `getNodeName` in interface `org.kie.api.runtime.process.NodeInstance`
      Overrides:
        `getNodeName` in class `NodeInstanceImpl`

    - #### getContextInstances

          public List<ContextInstance> getContextInstances​(String contextId)

      Specified by:
        `getContextInstances` in interface `ContextInstanceContainer`

    - #### addContextInstance

          public void addContextInstance​(String contextId,
                                         ContextInstance contextInstance)

      Specified by:
        `addContextInstance` in interface `ContextInstanceContainer`

    - #### removeContextInstance

          public void removeContextInstance​(String contextId,
                                            ContextInstance contextInstance)

      Specified by:
        `removeContextInstance` in interface `ContextInstanceContainer`

    - #### getContextInstance

          public ContextInstance getContextInstance​(String contextId,
                                                    long id)

      Specified by:
        `getContextInstance` in interface `ContextInstanceContainer`

    - #### getContextInstance

          public ContextInstance getContextInstance​(Context context)

      Specified by:
        `getContextInstance` in interface `ContextInstanceContainer`

    - #### getContextContainer

          public ContextContainer getContextContainer()

      Specified by:
        `getContextContainer` in interface `ContextInstanceContainer`

    - #### getSourceParameters

          protected Map<String,​Object> getSourceParameters​(DataAssociation association)

    - #### validateWorkItemResultVariable

          public void validateWorkItemResultVariable​(String processName,
                                                     List<DataAssociation> outputs,
                                                     org.drools.core.process.instance.WorkItem workItem)

    - #### addExceptionProcessListener

          public void addExceptionProcessListener()

    - #### removeExceptionProcessListeners

          public void removeExceptionProcessListeners()

    - #### getExceptionHandlingProcessInstanceId

          public long getExceptionHandlingProcessInstanceId()

    - #### internalSetProcessInstanceId

          public void internalSetProcessInstanceId​(long processInstanceId)

    - #### getTriggerCount

          public int getTriggerCount()

    - #### internalSetTriggerCount

          public void internalSetTriggerCount​(int triggerCount)

    - #### getKieRuntimeForExceptionSubprocess

          protected org.kie.api.runtime.KieRuntime getKieRuntimeForExceptionSubprocess()

    - #### getKieRuntimeForSubprocess

          protected org.kie.api.runtime.KieRuntime getKieRuntimeForSubprocess()

    - #### getKieRuntimeForSubprocess

          protected org.kie.api.runtime.KieRuntime getKieRuntimeForSubprocess​(org.kie.api.runtime.manager.Context<?> context)

    - #### setVariableStrictOption

          public static void setVariableStrictOption​(boolean turnedOn)